# [Tartan Background Image](https://github.com/acbarbosa1964/acb-tartan-background)

Pick a tartan image to use as a background in your Web Pages.

**From Wikipedia:**

>Tartan is a pattern consisting of criss-crossed horizontal and vertical bands in multiple colours. Tartans originated in woven wool, but now they are made in many other materials. Tartan is particularly associated with Scotland. Scottish kilts almost always have tartan patterns. Tartan is often called plaid in North America, but in Scotland, a plaid is a tartan cloth slung over the shoulder as a kilt accessory, or a plain ordinary blanket such as one would have on a bed.

>Tartan is made with alternating bands of coloured (pre-dyed) threads woven as both warp and weft at right angles to each other. The weft is woven in a simple twill, two over — two under the warp, advancing one thread at each pass. This forms visible diagonal lines where different colours cross, which give the appearance of new colours blended from the original ones. The resulting blocks of colour repeat vertically and horizontally in a distinctive pattern of squares and lines known as a sett.

![Screenshot](https://github.com/acbarbosa1964/acb-sample-gifs/blob/master/images/acb-tartan-background-example.gif?raw=true)

## How to Install
---

#### Git Clone

1. Under main menu select **Help > Show Extensions Folder**
2. Git clone this repository inside the folder user.

#### Extension Manager

1. Under main menu select **File > Extension Manager...**
2. Search for "ACB Tartan Background"
3. Click "Install"

## How to use
---

1. Your cursor must be in place to insert the resulting code after image pick
2. Open Images Dialog using the icon in right-hand column (quick launchpad)
3. Select an image to use as a background   
4. Click the Insert Button or simply close the window to cancel

## Credits
---

- Alex Bardanov (some code and extension tracking) (https://github.com/dnbard)
- Knockout JavaScript (Simplyfied dynamic content) library (http://knockoutjs.com)
- Lodash - JavaScript utility library (https://lodash.com/)
- Wikipedia Tartan contents (https://en.wikipedia.org/wiki/List_of_tartans)
- b64.io - Imagem converter (http://b64.io/)


Thank you!